$INTERFACE UA0DF1                                             98/12/01
  $IF(MODELY='YES') $SUBST('UZYSET')
  $IF(GRAPH='NO')
    $NA=1
    $MED=0
    $ADD(SINIT)
      NA=1
      MED=0
    $ENDADD
  $ELSE
    $HELP
      OUTPUT SPECIFICATION
        1 - OUTPUT IN ALL INTEGRATION STEPS
        2 - OUTPUT IN PRESCRIBED MESH POINTS
    $CHECK(MED,2,'1\2',4)
    $HELP
      NUMBER OF MESH POINTS
    $CHECK(NA,50,INT,1)
  $ENDIF
  $IF(MED=2)
    $ADD(SINID)
      CALL UESET1(NA,$AT,TA,TAMAX,HEMAX)
    $ENDADD
  $ENDIF
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
  $HELP
    TYPE OF METHOD
      DP5 - DORMAN PRINCE OF THE 5'TH ORDER
      DP8 - DORMAN PRINCE OF THE 8'TH ORDER
  $CHECK(SOLVER,'DP8','DP5\DP8\EX1',2,NO)
  $IF(MODELA='YES')
    $MEL='($NE+1)'
  $ELSE
    $MEL='$NE'
  $ENDIF
  $ADD(REAL,'\$AT($NA)\$AY($NA*$NE)\$YA($MEL)')
      $ADD(SINIT)
        CALL UXVSET(NE,ZERO,YA)
      $ENDADD
      $ADD(SINID)
        CALL UESET2(NA,NE,$AT,$AY,$YA,TA)
      $ENDADD
      $IF(MODELY='YES')
        $SUBST('UE0Y01')
        CALL UXVCOP(NE,$YA,$AY)
      $ENDIF
 $00  CALL UA0DF1(NA,NE,MEL,$AT,$AY,$YA,$ETA9,F,FF,TA,HE,MED,MED1,MED2&
,IER)
      GOTO ($40,$10,$30) ISB+1
 $10  CONTINUE
      $LET=$00
      $LED=$20
      $LES=$10
      $SUBST('UEV$SOLVER')
 $20  CONTINUE
      $SUBST('UE0DF1')
      $GO TO $10
 $30  CONTINUE
      $IF(MODELF='YES')
        $MTYPE=FMODF
        $SUBST('UZFMOD')
      $ENDIF
      $GO TO $00
 $40  CONTINUE
      $ADD(INIT)
        NAXX='UA0DF1'
      $ENDADD
      $EXIT
