$INTERFACE UA1DF1                                             98/12/01
  $IF(MODELY='YES') $SUBST('UZYSET')
  $IF(MODELF='NO')
    $GF='G'
    $DF='G'
  $ENDIF
  $MCG=0
  $IF(GRAPH='NO')
    $NA=1
    $MED=0
    $ADD(SINIT)
      NA=1
      MED=0
    $ENDADD
  $ELSE
    $HELP
      OUTPUT SPECIFICATION
        1 - OUTPUT IN ALL INTEGRATION STEPS
        2 - OUTPUT IN PRESCRIBED MESH POINTS
    $CHECK(MED,2,'1\2',4)
    $HELP
      NUMBER OF MESH POINTS
    $CHECK(NA,50,INT,1)
  $ENDIF
  $IF(MED=2)
    $ADD(SINID)
      CALL UESET1(NA,$AT,TA,TAMAX,HEMAX)
    $ENDADD
  $ENDIF
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
  $HELP
    TYPE OF METHOD
      DP5 - DORMAN PRINCE OF THE 5'TH ORDER
      DP8 - DORMAN PRINCE OF THE 8'TH ORDER
  $CHECK(SOLVER,'DP8','DP5\DP8\EX1',2,NO)
  $IF(MODELA='YES')
    $MEL='($NE*$NF+$NE+$NF+1)'
  $ELSE
    $MEL='($NE*$NF+$NE)'
  $ENDIF
  $ADD(REAL,'\$AT($NA)\$AY($NA*$NE)\$YA($MEL)\$G($NF)\$GE($NF)\$GF($NF)&
  \$DF($NE)')
      $ADD(SINIT)
        CALL UXVSET(NE,ZERO,YA)
      $ENDADD
      $ADD(SINID)
      CALL UESET2(NA,NE,$AT,$AY,$YA,TA)
      $ENDADD
      $LET=$00
      $LED=$30
      $LES=$20
 $00  CALL UA1DF1(NF,NA,NE,MEL,KE,$AT,$AY,$YA,$G,$GE,$GF,$DF,$ETA9,F,FF&
,FE,TA,HE,MED,MED1,MED2,IER)
      GOTO ($50,$10,$20,$40) ISB+1
 $10  CONTINUE
      $IF(MODELY='YES')
        $IF(LYD<0)
          $MTYPE=FMODY
          $SUBST('UZYMOD')
        $ELSE
          FE=$EF(KE)
          $EF(KE)=ZERO
        $ENDIF
        IF (KD.LE.0) GO TO $00
        $IF(LYD<1)
          $IF(GMODY='G')
            $MTYPE=GMODY
            $SUBST('UZYMOD')
          $ENDIF
        $ELSE
          CALL UXVCOP(NF,$EG((KE-1)*NF+1),$GE)
          CALL UXVSET(NF,ZERO,$EG((KE-1)*NF+1))
        $ENDIF
      $ENDIF
      $GO TO $00
 $20  CONTINUE
      $SUBST('UEV$SOLVER')
 $30  CONTINUE
      $SUBST('UE1DF1')
      $GO TO $20
 $40  CONTINUE
      $IF(MODELF='YES')
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        IF (KD.LE.0) GO TO $00
        $IF(GMODF='G')
          $MTYPE=GMODF
          $SUBST('UZFMOD')
        $ENDIF
        $IF(DMODF='D')
          $MTYPE=DMODF
          $SUBST('UZFMOD')
        $ENDIF
        $IF(GMODF='GD')
          $MTYPE=GMODF
          $SUBST('UZFMOD')
        $ENDIF
      $ENDIF
      $GO TO $00
 $50  CONTINUE
      IF (ITERM.NE.0) CALL UXVSET(NF,ZERO,G)
      $ADD(INIT)
        NAXX='UA1DF1'
      $ENDADD
      $EXIT
