$INTERFACE UD1TL1                                             98/12/01
  $IF(CONSTR='C')
    $ADD(REAL,'\UXUDOT')
    $ADD(REAL,'\$GN($NF)\$SN($NF)')
    IF (KD.GT.0) P=UXUDOT($N,$GN,$SN,$IX,KBF)
    CALL UD1TL1(NF,$N,$GN,$SN,EPS0,ALF1,ALF2,R,P,GNORM,SNORM,RMIN,RMAX&
,XMAX,XDEL,MES,INITD,INITH)
  $ELSE
    $ADD(REAL,'\UXVDOT')
    $ADD(REAL,'\$GN($NF)\$SN($NF)')
    IF (KD.GT.0) P=UXVDOT($N,$GN,$SN)
    CALL UD1TL1(NF,$N,$GN,$SN,EPS0,ALF1,ALF2,R,P,GNORM,SNORM,RMIN,RMAX&
,XMAX,XDEL,MES,INITD,INITH)
  $ENDIF
$REM  $ADD(INTEGER,'\NF\$N\MES\INITD\INITH')
$REM  $ADD(REAL,'\EPS0\ALF1\ALF2\R\P\GNORM\SNORM\RMIN\RMAX\XMAX\XDEL')
  $HELP
    CHOICE OF TEST ON DESCENT DIRECTION
     -1 - CHANGE OF DIRECTION
      0 - NO TEST
      1 - UNIFORM CRITERION
  $CHECK(INITD,1,'-1\0\1',4)
  $HELP
    TOLERANCE FOR DESCENT DIRECTION
  $CHECK(EPS0,'1.0$P-6',REAL,4)
  $HELP
    LOWER BOUND FOR STEPSIZE PARAMETER
  $CHECK(ALF1,'1.0$P-10',REAL,4)
  $HELP
    UPPER BOUND FOR STEPSIZE PARAMETER
  $CHECK(ALF2,'1.0$P 10',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XMAX,'1.0$P 3',REAL,2)
  $EXIT
