$INTERFACE UDPLI2                                             06/12/01
$REM VL
  $GR='GR'
  $XR='XR'
  $IF(CONSTR='C')
    $POM1='U'
    $POM2=',$$IX,KBF)'
    $ADD(INTEGER,'\$IX($NF)')
  $ELSE
    $POM1='V'
    $POM2=')'
  $ENDIF
  $ADD(REAL,'\$XM($NF*$MF)\$XR($MET5+1)\$GR($MET5+1)\$GN($NF)\$SN($NF)&
  \$XS($NF)\$GS($NF)\$SO(2*$NF*$MET5+1)')
  $ADD(REAL,'\UX$(POM1)DOT')
  CALL UOD1D1
  $ADD(INTEGER,'\J\NN\NM\MS\N2')
  $ADD(REAL,'\B\AP\AH\POM\RHO\TEMP')
$REM  $ADD(INTEGER,'\NF\MF')
  $IDECF=9
  IDECF=9
  IF (IDECF.EQ.9) THEN
  ELSE
  ITERD=-1
  TDXX='BAD DEC$IDECF'
  CALL UOERR1('UDPLI2',1)
  GO TO $90
  ENDIF
  GNORM=SQRT(UX$(POM1)DOT(NF,$GN,$GN$POM2)
  IF (NN.EQ.0) THEN
  CALL UXVNEG(NF,$GN,$SN)
  $GO TO $80
  ENDIF
$REM  RHO=ONE
  PAR3=PAR
  PAR=B/(AH+AP*4.0$P 0)
  TEMP=PAR3/(PAR3+PAR)*1.2$P 0
  $IF(MET3=1)
    POM=0.5$P 0
  $ELSE
    POM=MIN(MAX(ONE+RHO*(TEMP-ONE)*(RHO+PAR*AH/B)/(PAR*AH/B)**2,ZERO)&
,ONE)
  $ENDIF
  N2=NF+NF
  IF (MS.EQ.0) THEN
*
*     STRANG RECURRENCES ARE NOT USED
*
  CALL UDMUL1(NF,NN,$XM,$GN,$SN,$XO,$GO,AH,B,PAR,POM)
  GO TO $40
  ENDIF
  NM=NF*MS*2
  TEMP=UX$(POM1)DOT(NF,$XO,$GN$POM2/B
  CALL UX$(POM1)DIR(NF,-TEMP,$GO,$GN,$GS$POM2
*
*     BACKWARD STRANG RECURRENCES
*
  DO $20 J=NM-N2,0,-N2
  $GR(J/N2+1)=UX$(POM1)DOT(NF,$SO(J+1),$GS$POM2/$XR(J/N2+1)
  CALL UX$(POM1)DIR(NF,-$GR(J/N2+1),$SO(J+NF+1),$GS,$GS$POM2
$20 CONTINUE
  CALL UDMUL1(NF,NN,$XM,$GS,$SN,$XO,$GO,AH,B,PAR,POM)
*
*     FORWARD STRANG RECURRENCES
*
  DO $30 J=0,NM-N2,N2
  CALL UX$(POM1)DIR(NF,-(UX$(POM1)DOT(NF,$SO(J+NF+1)&
,$SN$POM2/$XR(J/N2+1)+$GR(J/N2+1)),$SO(J+1),$SN,$SN$POM2
$30 CONTINUE
  CALL UX$(POM1)DIR(NF,-(UX$(POM1)DOT(NF,$GO,$SN$POM2/B+TEMP*RHO)&
,$XO,$SN,$SN$POM2
*
*     MATRIX OF DIFFERENCES UPDATE
*
$40 CONTINUE
  IF (MET5.EQ.0) GO TO $80
  IF (MS.GE.MET5) THEN
  MS=MS-1
  CALL UXVCOP(MS,$XR(2),$XR)
  CALL UXVCOP(N2*MS,$SO(N2+1),$SO)
  ENDIF
  CALL UXVCOP(NF,$XO,$SO(N2*MS+1))
  CALL UXVCOP(NF,$GO,$SO(N2*MS+NF+1))
  MS=MS+1
  $XR(MS)=B
$80 CONTINUE
  $IF(CONSTR='C')
    CALL UX$(POM1)ZER(NF,$S$POM2
  $ENDIF
  INITD=MAX(ABS(INITD),1)
  ITERD=1
  SNORM=SQRT(UX$(POM1)DOT(NF,$SN,$SN$POM2)
$90 CALL UOD1D2(NF,$GN,$SN)
  $ADD(INIT)
    NDXX='UDPLI2'
  $ENDADD
  $ADD(SUBROUTINES)
* SUBROUTINE UDMUL1                ALL SYSTEMS                06/12/01
* PORTABILITY : ALL SYSTEMS
* 06/12/01 VL : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VECTOR S=-(XM*TRANS(XM)+ ZET*V_Q*TRANS(V_Q))*G WHERE
* V_Q=I+Q*TRANS(GO)/TRANS(GO)*Q.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES (NUMBER OF ROWS OF THE MATRIX XM).
*  II  M  NUMBER OF COLUMNS OF THE MATRIX XM.
*  RI  XM(N*M)  RECTANGULAR MATRIX FOR THE PRODUCT FORM VM
*         METHOD (STORED COLUMNWISE): BAR(H)=XM*TRANS(XM).
*  RI  G(N)  NEW GRADIENT.
*  RO  S(N)  DIRECTION VECTOR.
*  RI  XO(N)  VECTOR OF VARIABLES DIFFERENCE.
*  RI  GO(N)  GRADIENT DIFFERENCE.
*  RI  A  INPUT PARAMETER A=TRANS(GO)*GO.
*  RI  B  INPUT PARAMETER B=TRANS(GO)*XO.
*  RI  ZET  INPUT PARAMETER ZETA.
*  RI  ETA  BROYDEN PARAMETER FOR THE CORRECTION UPDATE.
*
* SUBPROGRAMS USED :
*  S   UXVDIR  VECTOR AUGMENTED BY A SCALED VECTOR.
*  RF  UXVDOT  DOT PRODUCT OF VECTORS.
*
    SUBROUTINE UDMUL1(N,M,XM,G,S,XO,GO,A,B,ZET,ETA)
    INTEGER N,M
    $FLOAT XM(N*M),G(N),S(N),XO(N),GO(N),A,B,ZET,ETA
    INTEGER I,J,L
    $FLOAT TET,TMP,UXVDOT
*
*     DETERMINATION OF THE VECTOR Q (PARAMETER TET)
*
    TET=ZET*A/B
$REM    TET=B/A*(1.0$P 0+SQRT((1.0$P 0+TET)/(1.0$P 0+ETA*TET)))
    TET=(ETA-1.0$P 0)*ZET/(1.0$P 0+ETA*TET&
+SQRT((1.0$P 0+TET)*(1.0$P 0+ETA*TET)))
*
*     S = TRANS(V_Q)*G
*
    TMP=0.0$P 0
    DO 1 I=1,N
    TMP=TMP+(XO(I)-TET*GO(I))*G(I)
  1 CONTINUE
    CALL UXVDIR(N,-TMP/(B-TET*A),GO,G,S)
*
*     S = -ZET*V_Q*S
*
    TMP=UXVDOT(N,GO,S)/(B-TET*A)
    DO 2 I=1,N
    S(I)=(-S(I)+(XO(I)-TET*GO(I))*TMP)*ZET
  2 CONTINUE
*
*     S = S + -U*TRANS(U)*G
*
    L=0
    DO 3 J=1,M
    CALL UXVDIR(N,-UXVDOT(N,XM(L+1),G),XM(L+1),S,S)
    L=L+N
  3 CONTINUE
    RETURN
    END
  $ENDADD
  $EXIT
