$INTERFACE UP2SA3                                             05/12/01
  $LHELP=.FALSE.
  $IF(KDA=2) $LHELP=.TRUE.
  $IF(NUMDER=1) $LHELP=.TRUE.
  $IF(LHELP)
  $SUBST('UZASET')
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'0.0$P 0',REAL,2)
  $HELP
    MAXIMUM NUMBER OF NONZERO ELEMENTS IN THE
    APPROXIMATED FUNCTION HESSIAN MATRIX
  $CHECK(MHA,100,INT,1)
  $ADD(SINID)
    $SUBST('UFSET8')
  $ENDADD
  $ADD(REAL,'\$GA($NF)\$HA($MHA)\$G($NF)\$H($M)\$AZ($NA)')
$REM  $ADD(REAL,'\FF\FA\F')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$IH($NF+1)\$JH($M)')
$REM  $ADD(INTEGER,'\NF\NA\NAL\MA\MHA\KA\M')
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     ---------------------------
*     PENALTY FUNCTION DEFINITION
*     ---------------------------
*
$OPTION(CHDIR=CHPOM)
 $00  CALL UP2SA3(NF,NA,NAL,MA,MHA,KA,M,$GA,$HA,$IAG,$JAG,$G,$H&
,$IH,$JH,$AZ,FF,FA)
      GO TO ($90,$10,$20,$50) ISB+1
 $10  CONTINUE
      $IF(SAVA>-1)
        IF(LDA.GE.0) THEN
        FA=$AF(KA)
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NAL<>0)
        IF(KA.LE.NAL) THEN
        $SUBST('UALNF3')
        $IF(KBA>0) $SUBST('UATRF1')
        $IF(ISNA>0)
          $SUBST('UASVF1')
        $ENDIF
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<0)
        $IF(NAL<>NA)
          $MTYPE=FMODA
          $SUBST('UZAMOD')
          $IF(NORMA>0) $SUBST('UANRF1')
          $IF(KBA>0) $SUBST('UATRF1')
          $IF(ISNA>0)
            $SUBST('UASVF1')
          $ENDIF
          $IF(FMODA<>'F')
            $IF(NORMA>0) $SUBST('UANRG1')
            $IF(ISNA>1)
              $SUBST('UASVG3')
            $ENDIF
          $ENDIF
          $IF(FMODA='FGH')
            $IF(NORMA>0) $SUBST('UANRH3')
          $ENDIF
          GO TO $00
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $20  CONTINUE
      $IF(SAVA>0)
        IF(LDA.GE.1) THEN
        $SUBST('UALNG3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NAL<>0)
        IF(KA.LE.NAL) THEN
        $SUBST('UALNG3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<1)
        $IF(NAL<>NA)
          $IF(GMODA='G')
            $MTYPE='G'
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRG1')
            $IF(ISNA>1)
              $SUBST('UASVG3')
            $ENDIF
            GO TO $00
          $ELSEIF(FMODA='F')
            $IF(ISNA>0)
              IF (LD.GE.0) FA=$AF(KA)
            $ENDIF
 $25  CONTINUE
            $SUBST('UA0G$(CON)3')
            GO TO ($40,$30) ISB+1
 $30  CONTINUE
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            GO TO $25
 $40  CONTINUE
            $IF(ISNA>1)
              $SUBST('UASVG3')
            $ENDIF
            GO TO $00
          $ELSEIF(.FALSE.)
            IF (LD.LT.0) GO TO $00
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            $IF(NORMA>0) $SUBST('UANRG1')
            $IF(ISNA>1)
              $SUBST('UASVG3')
            $ENDIF
            GO TO $00
          $ELSE
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $50  CONTINUE
      $IF(NAL<>0)
        IF(KA.LE.NAL) THEN
$REM        $SUBST('UALNH3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<2)
        $IF(NAL<>NA)
          $IF(HMODA='H')
            $MTYPE='H'
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRH3')
            GO TO $00
          $ELSEIF(GMODA='G')
            $SUBST('UA1H$(CON)3')
            GO TO ($00,$60) ISB+1
 $60  CONTINUE
            $MTYPE=GMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRG1')
            GO TO $50
          $ELSEIF(FMODA='F')
            $IF(ISNA>0)
              IF (LD.GE.0) FA=$AF(KA)
            $ENDIF
 $65  CONTINUE
            $SUBST('UA0H$(CON)3')
            GO TO ($00,$70) ISB+1
 $70  CONTINUE
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            GO TO $65
          $ELSEIF(FMODA='FG')
            $SUBST('UA1H$(CON)3')
            GO TO ($00,$80) ISB+1
 $80  CONTINUE
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRG1')
            GO TO $50
          $ELSEIF(.FALSE.)
            IF (LD.LT.0) GO TO $00
            $MTYPE=FMODA
            $SUBST('UZAMOD')
            $IF(NORMA>0) $SUBST('UANRF1')
            $IF(KBA>0) $SUBST('UATRF1')
            $IF(NORMA>0) $SUBST('UANRG1')
            $IF(NORMA>0) $SUBST('UANRH3')
            GO TO $00
          $ELSE
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $90  CONTINUE
      LD=KD
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     ----------------------------------
*     END OF PENALTY FUNCTION DEFINITION
*     ----------------------------------
*
$OPTION(CHDIR=CHPOM)
$ADD(INIT)
  NPXX='UP2SA3'
$ENDADD
$ELSE
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'0.0$P 0',REAL,2)
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     -------------------------
*     NUMERICAL DIFFERENTIATION
*     -------------------------
*
$OPTION(CHDIR=CHPOM)
      ISNAS=ISNA
 $00  CALL UP2PF3
      GO TO ($30,$10,$20) ISB+1
 $10  CONTINUE
      IF (TSS(NS).NE.'UPXX') THEN
      LD=MIN(LD,0)
      LDA=MIN(LDA,0)
      $IF(NAL<>NA)
        $IF(GMODA<>'G')
          $IF(FMODA='F')
            LD=-1
            LDA=-1
          $ENDIF
        $ENDIF
      $ENDIF
      ENDIF
      $SUBST('UP1SA3')
      IF (TSS(NS).EQ.'UPXX') GO TO $00
 $20  CONTINUE
      $GFS=GF
      $XSS=XS
      $XS=GS
      $GF=G
      $KHLP=1
$REM      $IF(KDA<1)
$REM        $IF(KDC<1) $KHLP=0
$REM      $ENDIF
      ISNA=0
      $SUBST('UF$(KHLP)H$(CON)2')
      GO TO ($00,$10) ISB+1
 $30  CONTINUE
      ISNA=ISNAS
      $GF=GFS
      $XS=XSS
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     --------------------------------
*     END OF NUMERICAL DIFFERENTIATION
*     --------------------------------
*
$OPTION(CHDIR=CHPOM)
$ADD(INIT)
  NPXX='UP1SA3'
  NFHX='UF$(KHLP)H$(CON)2'
$ENDADD
$ENDIF
$EXIT
