$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UZMODF                                    01/12/92  +
$REM + SI                                                            +
$REM + PURPOSE:  SPECIFICATION OF MODEL OF OBJECTIVE FUNCTION        +
$REM +---------------------------------------------------------------+

$GMODF='X'
$DMODF='X'
$HMODF='X'
$IF($DEF(FMODELF))
  $FMODF='F'
  $KDF=0
  $IF($DEF(GMODELF))
    $GMODF='G'
    $KDF=1
  $ENDIF
  $IF($DEF(DMODELF))
    $DMODF='D'
  $ENDIF
  $IF($DEF(HMODELF))
    $HMODF='H'
    $KDF=2
  $ENDIF
  $IF($DEF(GDMODELF))
    $GMODF='GD'
    $KDF=1
  $ENDIF
  $MODELF='YES'
  $EXIT
$ELSEIF($DEF(FGMODELF))
  $FMODF='FG'
  $KDF=1
  $IF($DEF(DMODELF))
    $DMODF='D'
  $ENDIF
  $IF($DEF(HMODELF))
    $HMODF='H'
    $KDF=2
  $ENDIF
  $MODELF='YES'
  $EXIT
$ELSEIF($DEF(FDMODELF))
  $FMODF='FD'
  $KDF=0
  $IF($DEF(GMODELF))
    $GMODF='G'
    $KDF=1
  $ENDIF
  $MODELF='YES'
  $EXIT
$ELSEIF($DEF(FGDMODELF))
  $FMODF='FGD'
  $KDF=1
  $MODELF='YES'
  $EXIT
$ELSEIF($DEF(FGHMODELF))
  $FMODF='FGH'
  $KDF=2
  $MODELF='YES'
  $EXIT
$ELSEIF(MODEL='D?')
  $HELP
    MODEL OF OBJECTIVE FUNCTION:

      FF = <FORTRAN_EXPRESSION>
  $CHECK(FMODELF,'*',STR,1,NO)
  $IF(FMODELF='*')
  $ELSE
  $FMODF='F'
  $KDF=0
  $MODELF='YES'
  $ENDIF
$ELSE
  $FMODF='F'
  $KDF=0
  $MODELF='YES'
  $REPEAT
    $HELP
      MODEL OF OBJECTIVE FUNCTION

        FF = <FORTRAN_EXPRESSION>
    $CHECK(FMODELF,'*',STR,1,NO)
    $IF(FMODELF='*')
      $IF(DIALOG>0)
        $ERASE(FMODELF)
      $ELSE
        $ERROR:  MODEL OF OBJECTIVE FUNCTION WAS NOT SPECIFIED.
        $STOP
      $ENDIF
    $ENDIF
  $UNTIL ($DEF(FMODELF))
  $HELP
    MODEL OF GRADIENT OF OBJECTIVE FUNCTION

      GF(1)  = <FORTRAN_EXPRESSION>
      GF(2)  = <FORTRAN_EXPRESSION>
        .
        .
      GF(NF) = <FORTRAN_EXPRESSION>
  $CHECK(GMODELF,'*',STR,1,NO)
  $IF(GMODELF='*')
    $ERASE(GMODELF)
  $ELSE
    $GMODF='G'
    $KDF=1
  $ENDIF
  $IF($DEF(NE))
    $IF(NE>0)
      $HELP
        MODEL OF DERIVATIVES OF THE OBJECTIVE FUNCTION

          DF(1)  = <FORTRAN_EXPRESSION>
          DF(2)  = <FORTRAN_EXPRESSION>
            .
            .
          DF(NF) = <FORTRAN_EXPRESSION>
      $CHECK(DMODELF,'*',STR,1,NO)
      $IF(DMODELF='*')
        $ERASE(DMODELF)
      $ELSE
        $DMODF='D'
      $ENDIF
    $ENDIF
  $ENDIF
  $HELP
    MODEL OF HESSIAN MATRIX

      HF(1) = <FORTRAN_EXPRESSION>
      HF(2) = <FORTRAN_EXPRESSION>
        .
        .
      HF(M) = <FORTRAN_EXPRESSION>
  $CHECK(HMODELF,'*',STR,1,NO)
  $IF(HMODELF='*')
    $ERASE(HMODELF)
  $ELSE
    $HMODF='H'
    $KDF=2
  $ENDIF
$ENDIF

